#
# IObjectFactories
#
# Object factory interfaces
#
# Copyright (c) 2001-2003 by Philipp "philiKON" von Weitershausen
#
# This software is distributed under the terms of the Mozilla Public
# License (MPL)
#

"""
$Id: ObjectFactories.py,v 1.2 2003/05/21 00:03:59 philipp Exp $
"""

from Interface import Interface

class IFactoryRegistry(Interface):

    def register(meta_type, obj):
        """
        Register factory object 'obj' for meta type 'meta_type'
        """

    def getFactory(meta_type):
        """
        Return factory object for meta type 'meta_type'
        """

    def getSupportedMetaTypes():
        """
        Return a sequence with supported meta types
        """

class IObjectFactory(Interface):
    """
    Object factory interface
    """

    def createObject(id, title, data, **kw):
        """
        Create an object
        """
