
"""
$Id: testPropertySerializer.py,v 1.2 2003/05/21 00:04:00 philipp Exp $
"""

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.RevisionManager.Properties import PropertySerializer
from Products.RevisionManager.interfaces.Properties import IPropertySerializer

ZopeTestCase.installProduct('RevisionManager')

class PropertySerializerTest(ZopeTestCase.ZopeTestCase):

    def afterSetUp(self):
        self.serializer = PropertySerializer()

    def afterClear(self):
        pass

    def test_verify_interface(self):
        """Verify interface implementation"""
        from Interface.Verify import verifyClass
        self.failUnless(verifyClass(IPropertySerializer, PropertySerializer))

    def test_serialize(self):
        """Test serializing/deserializing"""
        serializer = self.serializer
        expected = (
             {'id':'some',   'value':'thing', 'type': 'string'},
             {'id':'any',    'value':'body',  'type': 'string'},
             {'id':'number', 'value':234,     'type': 'int'}
            )
        serial = serializer.serialize(expected)
        result = serializer.deserialize(serial)
        self.assertEqual(expected, result)

if __name__ == '__main__':
    framework(descriptions=1, verbosity=2)
else:
    import unittest
    def test_suite():
        suite = unittest.TestSuite()
        suite.addTest(unittest.makeSuite(PropertySerializerTest))
        return suite

